#!/usr/bin/env julia
module XmlTestReport
import Test
using Test: AbstractTestSet, FallbackTestSet, FallbackTestSetException,
            Fail, Error, Pass, Broken, DefaultTestSet, Result, ExecutionResult,
            Returned, get_testset, get_test_counts, get_testset_depth, TESTSET_PRINT_ENABLE,
            print_test_results, filter_errors, TestSetException, myid, scrub_backtrace, backtrace,
            @test, @test_throws, @test_broken, @test_skip, @test_warn, @test_nowarn,
            @test_logs, @test_deprecated, @testset, @inferred, Threw
import Test: record
export @test, @test_throws, @test_broken, @test_skip, @test_warn, @test_nowarn,
       @test_logs, @test_deprecated, @testset, @inferred

export detect_ambiguities, detect_unbound_args
export GenericString, GenericSet, GenericDict, GenericArray
export TestSetException
export @test_toxml

const TESTFILE = Ref("testreport.xml")
mutable struct Pass2 <: Result
    test_type::Symbol
    orig_expr
    data
    value
    source::LineNumberNode
end

using Base.CoreLogging: LogState, Warn, current_logstate, current_logger
const OLD_LOGSTATE = current_logstate()
current_task().logstate = LogState(Warn+100, current_logger())

function get_testio(fcn)
    testios = get(task_local_storage(), :__BASETESTNEXTIO__, IOBuffer[])
    io      = isempty(testios) ? open(TESTFILE[], "a") : testios[end]
    try
        fcn(io)
    finally
        (io isa IOStream) &&close(io)
    end
end

function _xmltestcase(t, other = "")
    get_testio() do io
        fname = "$(something(t.source.file, :none))"[length(pwd())+2:end]
        cname = replace(replace(fname[1:end-3], "/" => "."), "\\" => ".")
        line  = t.source.line
        println(
            io,
            string(
                "<testcase classname=\"$cname\" file=\"$fname\"",
                " line=\"$line\" name=\"line_$line\" time=\"0\">",
                other,
                "</testcase>"
            )
        )
    end
end

function _xmlfailuretestcase(t)
    buf = IOBuffer()
    Base.show(buf, t)
    str = replace(
        replace(replace(String(take!(buf)), "\"" => "&quot;"), "<" => "&lt;"),
        ">" => "&gt;"
    )

    _xmltestcase(t, "<failure message=\"$(str)\"</failure>")
end

macro test_toxml(tests, name = :("testreport.xml"))
    quote
        TESTFILE[] = $name
        println("Tests reported to $(TESTFILE[])")
        open(TESTFILE[], "w") do io
            println(io, "<?xml version=\"1.0\" encoding=\"utf-8\"?>")
            println(io, "<testsuite name=\"tests\">")
        end
        try
            $tests
        finally
            open(TESTFILE[], "a") do io
                println(io, "</testsuite>")
            end
        end
    end
end

function Test.push_testset(ts::AbstractTestSet)
    testsets = get(task_local_storage(), :__BASETESTNEXT__, AbstractTestSet[])
    push!(testsets, ts)
    setindex!(task_local_storage(), testsets, :__BASETESTNEXT__)

    testios = get(task_local_storage(), :__BASETESTNEXTIO__, IOBuffer[])
    push!(testios, IOBuffer())
    setindex!(task_local_storage(), testios, :__BASETESTNEXTIO__)
end

function pop_testio(fcn)
    testios = get(task_local_storage(), :__BASETESTNEXTIO__, IOBuffer[])
    ret = isempty(testios) ? open(FILE, "a") : pop!(testios)
    setindex!(task_local_storage(), testios, :__BASETESTNEXTIO__)
    try
        fcn(ret)
    finally
        close(ret)
    end
end

function Test.do_test(result::ExecutionResult, orig_expr)
    # get_testset() returns the most recently added test set
    # We then call record() with this test set and the test result
    if isa(result, Returned)
        # expr, in the case of a comparison, will contain the
        # comparison with evaluated values of each term spliced in.
        # For anything else, just contains the test expression.
        # value is the evaluated value of the whole test expression.
        # Ideally it is true, but it may be false or non-Boolean.
        value = result.value
        testres = if isa(value, Bool)
            # a true value Passes
            value ? Pass2(:test, orig_expr, result.data, value, result.source) :
                    Fail(:test, orig_expr, result.data, value, result.source)
        else
            # If the result is non-Boolean, this counts as an Error
            Error(:test_nonbool, orig_expr, value, nothing, result.source)
        end
    else
        # The predicate couldn't be evaluated without throwing an
        # exception, so that is an Error and not a Fail
        @assert isa(result, Threw)
        testres = Error(:test_error, orig_expr, result.exception, result.backtrace, result.source)
    end
    record(get_testset(), testres)
end
#
# An internal function, called by the code generated by @test_throws
# to evaluate and catch the thrown exception - if it exists
function Test.do_test_throws(result::ExecutionResult, @nospecialize(orig_expr), @nospecialize(extype))
    if isa(result, Threw)
        # Check that the right type of exception was thrown
        success = false
        exc = result.exception
        if isa(extype, Type)
            success = isa(exc, extype)
        else
            if isa(exc, typeof(extype))
                success = true
                for fld in 1:nfields(extype)
                    if !(getfield(extype, fld) == getfield(exc, fld))
                        success = false
                        break
                    end
                end
            end
        end
        if success
            testres = Pass2(:test_throws, orig_expr, extype, exc, result.source)
        else
            testres = Fail(:test_throws_wrong, orig_expr, extype, exc, result.source)
        end
    else
        testres = Fail(:test_throws_nothing, orig_expr, extype, nothing, result.source)
    end
    record(get_testset(), testres)
end

Test.record(ts::FallbackTestSet, t::Union{Fail,Error}) = (_xmlfailuretestcase(t); t)

function Test.record(ts::FallbackTestSet, t::Pass2)
    _xmltestcase(t)
    Pass(t.test_type, nothing, nothing, t.value)
end

function Test.record(ts::DefaultTestSet,  t::Pass2)
    ts.n_passed += 1;
    _xmltestcase(t)
    Pass(t.test_type, nothing, nothing, t.value)
end

# For the other result types, immediately print the error message
# but do not terminate. Print a backtrace.
function Test.record(ts::DefaultTestSet, t::Union{Fail, Error})
    if myid() == 1
        printstyled(ts.description, ": ", color=:white)
        # don't print for interrupted tests
        if !(t isa Error) || t.test_type != :test_interrupted
            print(t)
            # don't print the backtrace for Errors because it gets printed in the show
            # method
            if !isa(t, Error)
                Base.show_backtrace(stdout, scrub_backtrace(backtrace()))
            end
            println()
        end
    end
    _xmlfailuretestcase(t)
    push!(ts.results, t)
    t, isa(t, Error) || backtrace()
end

# Called at the end of a @testset, behaviour depends on whether
# this is a child of another testset, or the "root" testset
function Test.finish(ts::DefaultTestSet)
    passes, fails, errors, broken, c_passes, c_fails, c_errors, c_broken = get_test_counts(ts)
    total_pass   = passes + c_passes
    total_fail   = fails  + c_fails
    total_error  = errors + c_errors
    total_broken = broken + c_broken
    total = total_pass + total_fail + total_error + total_broken

    buf  = IOBuffer()
    println(
        buf,
        string(
            "<testsuite name=\"$(ts.description)\"",
            " errors=\"$(total_error)\"",
            " failures=\"$(total_fail)\"",
            " skipped=\"$(total_broken)\"",
            " tests=\"$(total)\"",
            " time=\"0\"",
            ">"
        )

    )
    pop_testio() do my_buf
        str = String(take!(my_buf))
        get_testio() do io
            println(io, String(take!(buf)), str,  "</testsuite>")
        end
    end

    # If we are a nested test set, do not print a full summary
    # now - let the parent test set do the printing
    if get_testset_depth() != 0
        # Attach this test set to the parent test set
        parent_ts  = get_testset()
        record(parent_ts, ts)
        return ts
    end

    if TESTSET_PRINT_ENABLE[]
        print_test_results(ts)
    end

    # Finally throw an error as we are the outermost test set
    if total != total_pass + total_broken
        # Get all the error/failures and bring them along for the ride
        efs = filter_errors(ts)
        throw(TestSetException(total_pass,total_fail,total_error, total_broken, efs))
    end

    # return the testset so it is returned from the @testset macro
    ts
end
current_task().logstate = OLD_LOGSTATE
end # module
